/******************************************************************************
Copyright (C) 2011-2012 Linagora

This program is free software: you can redistribute it and/or modify it under
the terms of the GNU Affero General Public License as published by the Free
Software Foundation, either version 3 of the License, or (at your option) any
later version, provided you comply with the Additional Terms applicable for OBM
connector by Linagora pursuant to Section 7 of the GNU Affero General Public
License, subsections (b), (c), and (e), pursuant to which you must notably (i)
retain the “Message sent thanks to OBM, Free Communication by Linagora”
signature notice appended to any and all outbound messages (notably e-mail and
meeting requests), (ii) retain all hypertext links between OBM and obm.org, as
well as between Linagora and linagora.com, and (iii) refrain from infringing
Linagora intellectual property rights over its trademarks and commercial
brands. Other Additional Terms apply, see <http://www.linagora.com/licenses/>
for more details.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License and
its applicable Additional Terms for OBM along with this program. If not, see
<http://www.gnu.org/licenses/> for the GNU Affero General   Public License
version 3 and <http://www.linagora.com/licenses/> for the Additional Terms
applicable to OBM connectors.
******************************************************************************/



// Init logger
var mLogger = Components.classes["@obm.org/calendar/logger;1"].createInstance(Components.interfaces.obmILogger);
var mWriter = Components.classes["@obm.org/calendar/writer;1?type=unixfile"].getService(Components.interfaces.obmILoggerWriter);
mLogger.setLevelWriter(gLogger.LOAD_LEVEL, mWriter);
mLogger.setHeader("=== mainOverlay: ");

Components.utils.import("resource://obm-extension/modules/UtilsOBM.jsm");
Components.utils.import("resource://calendar/modules/calUtils.jsm");

var scriptLoader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].createInstance(Components.interfaces.mozIJSSubScriptLoader);
if (typeof(OBM_Synchronize) == "undefined") {
	scriptLoader.loadSubScript("chrome://obm-extension/content/extension.js");
}
if (UtilsOBM.isLightningInstalledAndEnabled() && typeof(Calendar_Event_Synchronizer) == "undefined") {
	scriptLoader.loadSubScript("chrome://obm-extension/content/synchronizer/Calendar_Event_Synchronizer.js");
}
if (typeof(AddressBook_Contact_Synchronizer) == "undefined") {
	scriptLoader.loadSubScript("chrome://obm-extension/content/synchronizer/AddressBook_Contact_Synchronizer.js");
}

function OBM_RegisterCalendarManagerObserver() {
	var calendarManagerObserver = {
		onCalendarUnregistering: function(aCalendar) {
			if (aCalendar.type == "obm") {
				var calendarSynchronizer = new Calendar_Base_Synchronizer();
				calendarSynchronizer.notifyContainerDeleted(aCalendar);
			}
		},

		onCalendarRegistered: function(aCalendar) {},
		onCalendarDeleting: function(aCalendar) {},
		onCalendarPrefSet: function(aCalendar, aName, aValue) {},
		onCalendarPrefDeleting: function(aCalendar, aName) {},
		onCalendarPrefChanged: function(aCalendar, aName, aValue, aOldValue) {}
	};

	cal.getCalendarManager().addObserver(calendarManagerObserver);
}

var gAddressBookListener = {
	mContactSynchronizer: new AddressBook_Contact_Synchronizer(),

	// void onItemRemoved(nsISupports parentDir, nsISupports item) /
	onItemRemoved: function(parentDir, item) {
		try {

			/*
		mLogger.debug("MyAbListener::onItemRemoved()", false, false
									 + "\tparentDir: nsIAbDirectory: " + (parentDir instanceof Components.interfaces.nsIAbDirectory), false, false
									 + "\t           nsIAbCard: " + (parentDir instanceof Components.interfaces.nsIAbCard), false, false
									 + "\titem: nsIAbDirectory: " + (item instanceof Components.interfaces.nsIAbDirectory), false, false
									 + "\t      nsIAbCard: " + (item instanceof Components.interfaces.nsIAbCard) +"\n");
									 */

			if (item instanceof Components.interfaces.nsIAbCard) {
				var card = item.QueryInterface(Components.interfaces.nsIAbCard);
				if (card.isMailList) {
					return;
				}
				var directory = parentDir.QueryInterface(Components.interfaces.nsIAbDirectory);
				this.mContactSynchronizer.notifyItemDeleted(directory, card);

			} else if (item instanceof Components.interfaces.nsIAbDirectory) {
				var directory = item.QueryInterface(Components.interfaces.nsIAbDirectory);
				this.mContactSynchronizer.notifyContainerDeleted(directory);
			}

		} catch(e) {
			mLogger.error("MyAbListener::onItemRemoved()" + e, true, false);
		}
	},

	//- void onItemAdded(nsISupports parentDir, nsISupports item)
	onItemAdded: function(parentDir, item) {
		try {

			mLogger.debug("MyAbListener::onItemAdded()", false, false);

			if (item instanceof Components.interfaces.nsIAbCard) {
				var card = item.QueryInterface(Components.interfaces.nsIAbCard);
				if (card.isMailList) {
					return;
				}

				var directory = parentDir.QueryInterface(Components.interfaces.nsIAbDirectory);

				this.mContactSynchronizer.notifyItemAdded(directory, card);
			}
		} catch(e) {
			mLogger.error("MyAbListener::onItemAdded()" + e, true, false);
		}
	},

	//-void onItemPropertyChanged(nsISupports item, char* property,
	//-                              PRUnichar* oldValue, PRUnichar* newValue)
	onItemPropertyChanged: function(item, property, oldValue, newValue) {
		let caller = this.onItemPropertyChanged.caller;

		while (caller) {
			if(/SendMessage/i.test(caller.name)) {
				mLogger.debug("Ignoring MyAbListener::onItemPropertyChanged() callback while sending an email.", false, false);
				return;
			}
			caller = caller.caller;
		}
	    
		try {

			mLogger.debug("MyAbListener::onItemPropertyChanged():" + "item: " + item + ", property: " + property + ", " + "oldValue: " + oldValue + ", newValue: " + newValue, false, false);

			if (item instanceof Components.interfaces.nsIAbCard) {
				mLogger.debug("MyAbListener::onItemPropertyChanged(): changed addressbook card", false, false);

				let card = item.QueryInterface(Components.interfaces.nsIAbCard);
				if (card.isMailList) {
					return;
				}
				// does it belong to OBM address books ?
				// TODO. this big loop can be reduced to about 15 lines
                let obmAbMgr = UtilsOBM.getAddressbookManager();
                let mozAbMgr = Components.classes["@mozilla.org/abmanager;1"]
                                         .getService(Components.interfaces.nsIAbManager);
                for each (let book in obmAbMgr.getObmAddressBooks({})) {
                    if (UtilsOBM.isUsersAddressBook(book.uid)) {
                        mLogger.debug("MyAbListener::onItemPropertyChanged(): change in user addressbok, ignoring", false, false);
                        //Users are readonly do not notify
                        continue;
                    }
                    let dirName = "ldap_2.servers." + book.uid;
                    let iter = mozAbMgr.directories;
                    let directory = book.directory
                    try {
                        let obmId = card.getProperty("ObmId", false);
                        if (book.directory && book.directory.hasCard(card) &&
                            book.directory.getCardFromProperty("ObmId", obmId, false)) {
                            this.mContactSynchronizer.notifyItemModified(book.directory, card);
                            return;
                        }
                    } catch(e) {
                        cal.ERROR(e);
                    }
                }
			} else if (item instanceof Components.interfaces.nsIAbDirectory) {
				mLogger.debug("MyAbListener::onItemPropertyChanged(): this is a change in a directory item", false, false);
				if (property == "dirName") {
					// XXX: should we update the prefs extensions.obm.addressbooks.contacts, extensions.obm.addressbooks.users etc?
					// not activated for the moment, we should study this possibility. here is the code to do it.
					/*
					if ( oldValue == UtilsOBM.getLocalizedPref("extensions.obm.addressbooks.contacts")) { // this is the obm contact ab
						UtilsOBM.setPrefSafe("extensions.obm.addressbooks.contacts", newValue);
					}
					else if ( oldValue == UtilsOBM.getLocalizedPref("extensions.obm.addressbooks.users")) {
						UtilsOBM.setPrefSafe("extensions.obm.addressbooks.users", newValue);
					}
					else if ( oldValue == UtilsOBM.getLocalizedPref("extensions.obm.addressbooks.collected_contacts")) {
						UtilsOBM.setPrefSafe("extensions.obm.addressbooks.collected_contacts", newValue);
					}*/
				}
            } else {
                mLogger.debug("MyAbListener::onItemPropertyChanged(): processing unknown item " + item, false, false)
            }
		} catch(e) {
			mLogger.error("MyAbListener::onItemPropertyChanged()" + e, true, false);
		}
	}
};

function OBM_RegisterAddressBookListener() {
	//-    Address Book listener events:
	//-     - An address book, mailing list or card is added
	//-     - A mailing list or card is removed from an address book
	//-     - An address book is removed
	//-     - An address book, mailing list or card is changed
    var addressBookSession = Components.classes["@mozilla.org/abmanager;1"].getService(Components.interfaces.nsIAbManager);
    addressBookSession.addAddressBookListener(gAddressBookListener, Components.interfaces.nsIAbListener.all);
}

function OBM_UnRegisterAddressBookListener() {
	//-    Address Book listener events:
	//-     - An address book, mailing list or card is added
	//-     - A mailing list or card is removed from an address book
	//-     - An address book is removed
	//-     - An address book, mailing list or card is changed
    var addressBookSession = Components.classes["@mozilla.org/abmanager;1"].getService(Components.interfaces.nsIAbManager);
    addressBookSession.removeAddressBookListener(gAddressBookListener);
}

// Check "reset now" pref is set to true
// (Adding it into a closure to be able to delay it of 5s)
setTimeout(function() {
	if (UtilsOBM.getPrefSafe("extensions.obm.resetonstartup", false)) {
		mLogger.notice("Reset on startup asked by preference: extensions.obm.resetonstartup", false, false);
		UtilsOBM.setPrefSafe("extensions.obm.resetonstartup", false)
		UtilsOBM.reset();
	} else {
		mLogger.notice("Preference 'extensions.obm.resetonstartup' not set: no reset asked", false, false);
	}
}, 5000);

// Thunderbird
if (Components.interfaces.nsIAbDirectory) {
	OBM_RegisterAddressBookListener();
}

if (Components.interfaces.calICalendar) {
	OBM_RegisterCalendarManagerObserver();
}

//reset pref after a reset
UtilsOBM.setSyncOnQuitAfterReset();

(function() {
    let info = Components
                    .classes["@mozilla.org/xre/app-info;1"]
                    .getService(Components.interfaces.nsIXULAppInfo);
    let majorVersion = parseInt(info.version.split(".").shift(), 10);
    let lastVersion = UtilsOBM.getPrefSafe("extensions.obm.connector.lastVersion", 3);
    
    mLogger.notice("Running OBM Connector v" + UtilsOBM.getOrigin.obmVersion + " in Thunderbird v" + info.version);
    
    UtilsOBM.setPrefSafe("extensions.obm.connector.lastVersion", majorVersion);
    
    if (lastVersion != majorVersion) {
      let promptService = Components
                              .classes["@mozilla.org/embedcomp/prompt-service;1"]
                              .getService(Components.interfaces.nsIPromptService);
      let title = UtilsOBM.getLocalizedMessage("obm.tbirdupgrade.title");
      let message = UtilsOBM.getLocalizedMessage("obm.tbirdupgrade.message");
      
      promptService.alert(null, title, message);
      
      UtilsOBM.reset(UtilsOBM.restartThunderbird);
    }
})();

// autoconf : subscribe to calendar and remove lightning default calendar
// TODO this is deeply misplaced...
let autoconfedLogin = UtilsOBM.getPrefSafe("extensions.obm.autoconf.login", null);
if (autoconfedLogin) {
	if (!UtilsOBM.getOBMCredentials({},
	{})) {
		UtilsOBM.setOBMCredentials(autoconfedLogin, "");
		mLogger.debug("login intialized with autoconfed login " + autoconfedLogin, false, false);
	}
}

// OBMFULL-5284, mark item as declined in case its an invitation.
(function() {
    function obmDeleteSelectedEvents() {
        let selectedItems = currentView().getSelectedItems({});
        let firstSelectedItem = selectedItems[0];
        let firstCalendar = firstSelectedItem && firstSelectedItem.calendar;
        let schedCalendar = cal.wrapInstance(firstCalendar, Components.interfaces.calISchedulingSupport);
        if (schedCalendar && schedCalendar.isInvitation(firstSelectedItem)) {
            if (firstSelectedItem.recurrenceId) {
                let [itemToDelete, hasFutureItem, response] = promptOccurrenceModification(firstSelectedItem, false, "delete");
                firstSelectedItem = itemToDelete;
            }
            let modifiedItem = firstSelectedItem.clone();
            let attendee = schedCalendar.getInvitedAttendee(modifiedItem);
            if (!firstCalendar.readOnly && attendee) {
                modifiedItem.removeAttendee(attendee);
                attendee.participationStatus = "DECLINED";
                modifiedItem.addAttendee(attendee);
                doTransaction('modify', modifiedItem, firstCalendar, firstSelectedItem, null);
            }
        } else {
           calRemoveSelectedEvents();
        }
    }

    let calRemoveSelectedEvents = deleteSelectedEvents;
    deleteSelectedEvents = obmDeleteSelectedEvents;
})();
