/******************************************************************************
Copyright (C) 2011-2012 Linagora

This program is free software: you can redistribute it and/or modify it under
the terms of the GNU Affero General Public License as published by the Free
Software Foundation, either version 3 of the License, or (at your option) any
later version, provided you comply with the Additional Terms applicable for OBM
connector by Linagora pursuant to Section 7 of the GNU Affero General Public
License, subsections (b), (c), and (e), pursuant to which you must notably (i)
retain the “Message sent thanks to OBM, Free Communication by Linagora”
signature notice appended to any and all outbound messages (notably e-mail and
meeting requests), (ii) retain all hypertext links between OBM and obm.org, as
well as between Linagora and linagora.com, and (iii) refrain from infringing
Linagora intellectual property rights over its trademarks and commercial
brands. Other Additional Terms apply, see <http://www.linagora.com/licenses/>
for more details.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License and
its applicable Additional Terms for OBM along with this program. If not, see
<http://www.gnu.org/licenses/> for the GNU Affero General   Public License
version 3 and <http://www.linagora.com/licenses/> for the Additional Terms
applicable to OBM connectors.
******************************************************************************/

// mail sending observer

function SendObserver() {
  this.register();
}

SendObserver.prototype = {
	observe: function(subject, topic, data) {
		/* thunderbird sends a notification even when it's only saving the message as a draft.
		* We examine the caller chain to check for valid send notifications 
		*/
		var f = this.observe;
		while (f) {
			if(/Save/.test(f.name)) {
				return;
			}
			f = f.caller;
		}
		var locales = window.document.getElementById("community-bundle");
		var editorElement = window.GetCurrentEditorElement();
		var editorDocument = editorElement.contentDocument;
		var b = editorDocument.getElementsByTagName("body");
		b = b[0];
		var signatureContainer = document.createElement("div");
		var nag = ["--"].concat(locales.getString("obm.emailSignature").split("\n"));
		// no signature defined
		if ( nag.length < 2 ) {
			return ;
		}
		
		var inHTML = (new XMLSerializer()).serializeToString(b).replace(/<br \/>/g,"");
		if ( inHTML.indexOf(nag[1]) > -1 ) {
			return ;
		}
		
// 		var nag = [
// 			"--",
// 			"This email has been sent with OBM ( http://www.obm.org/ ).\n",
// 			"Made at Linagora !\n"
// 		];
		
		for ( var i in nag ) {
				var lineContainer = document.createElement("div");
				lineContainer.appendChild(document.createTextNode(nag[i]+"\n"));
				signatureContainer.appendChild(lineContainer);
				if ( (i + 1) < nag.length ) {
					signatureContainer.appendChild(document.createElement("br"));
				}
		}

		b.appendChild(signatureContainer);
	},
	register: function() {
		var observerService = Components.classes["@mozilla.org/observer-service;1"]
							.getService(Components.interfaces.nsIObserverService);
		observerService.addObserver(this, "mail:composeOnSend", false);
	},
	unregister: function() {
		var observerService = Components.classes["@mozilla.org/observer-service;1"]
								.getService(Components.interfaces.nsIObserverService);
		observerService.removeObserver(this, "mail:composeOnSend");
	}
};


/*
 * Register observer for send events. Check for event target to ensure that the 
 * compose window is loaded/unloaded (and not the content of the editor).
 * 
 * Unregister to prevent memory leaks (as per MDC documentation).
 */
var sendObserver;
window.addEventListener('load', function (e) {if (e.target == document) sendObserver = new SendObserver(); }, true);
window.addEventListener('unload', function (e) { if (e.target == document) sendObserver.unregister();}, true);
