/* Connection Window */

Components.utils.import("resource://obm-extension/modules/UtilsOBM.jsm");
Components.utils.import("resource://obm-extension/modules/GlobalData.jsm");

function OBM_LoadConnectionSettings() {
    document.getElementById("syncLocation").value = UtilsOBM.getPrefSafe("extensions.obm.server", "");
    document.getElementById("webLocation").value = UtilsOBM.getPrefSafe("extensions.obm.obmUrl", "");
    var username = {};
    var password = {};
    if ( UtilsOBM.getOBMCredentials(username, password) ) {
        document.getElementById("username").value = username.value;
        document.getElementById("password").value = password.value;
    }
    document.getElementById("savepassword").checked = UtilsOBM.getPrefSafe("extensions.obm.rememberpassword", true);
}
function OBM_LoadPasswordSettings() {
    var username = {};
    var password = {};
    if ( UtilsOBM.getOBMCredentials(username, password) ) {
        if (password.value != UtilsOBM.PASSWORD_NOT_CONFIGURED) {
            document.getElementById("password").value = password.value;
        } else {
            document.getElementById("password").value = "";
        }
    }
    document.getElementById("savepassword").checked = UtilsOBM.getPrefSafe("extensions.obm.rememberpassword", true);
}

function OBM_SaveConnectionSettings(cancel) {
    try {
        OBMGlobalData.canceled = cancel;
        if (cancel) {
            return;
        }

        UtilsOBM.setPrefSafe("extensions.obm.server", document.getElementById("syncLocation").value);
        UtilsOBM.setPrefSafe("extensions.obm.obmUrl", document.getElementById("webLocation").value);

        var remember = document.getElementById("savepassword").checked;
        UtilsOBM.setPrefSafe("extensions.obm.rememberpassword",remember);

        if (remember){
            UtilsOBM.setOBMCredentials(document.getElementById("username").value,
                        document.getElementById("password").value);
        } else {
            UtilsOBM.setOBMCredentials(document.getElementById("username").value, "");
            UtilsOBM.setTemporaryPassword(document.getElementById("password").value);
        }
    } catch (e) {
        gLogger.error(e,true,false);
    }
}

function OBM_SavePasswordSettings(cancel) {
    OBMGlobalData.canceled = cancel;
    if (cancel) {
        return;
    }
    UtilsOBM.setPrefSafe("extensions.obm.rememberpassword",
        document.getElementById("savepassword").checked);
    if (document.getElementById("savepassword").checked){
        var username = {};
        var password = {};
        if (UtilsOBM.getOBMCredentials(username, password)){
            UtilsOBM.setOBMCredentials(username.value,
            document.getElementById("password").value);
        } else {
            UtilsOBM.setTemporaryPassword(document.getElementById("password").value);
        }
    } else {
        UtilsOBM.setTemporaryPassword(document.getElementById("password").value);
    }
}
