/******************************************************************************
Copyright (C) 2011-2012 Linagora

This program is free software: you can redistribute it and/or modify it under
the terms of the GNU Affero General Public License as published by the Free
Software Foundation, either version 3 of the License, or (at your option) any
later version, provided you comply with the Additional Terms applicable for OBM
connector by Linagora pursuant to Section 7 of the GNU Affero General Public
License, subsections (b), (c), and (e), pursuant to which you must notably (i)
retain the “Message sent thanks to OBM, Free Communication by Linagora”
signature notice appended to any and all outbound messages (notably e-mail and
meeting requests), (ii) retain all hypertext links between OBM and obm.org, as
well as between Linagora and linagora.com, and (iii) refrain from infringing
Linagora intellectual property rights over its trademarks and commercial
brands. Other Additional Terms apply, see <http://www.linagora.com/licenses/>
for more details.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License and
its applicable Additional Terms for OBM along with this program. If not, see
<http://www.gnu.org/licenses/> for the GNU Affero General   Public License
version 3 and <http://www.linagora.com/licenses/> for the Additional Terms
applicable to OBM connectors.
******************************************************************************/

Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");
Components.utils.import("resource://obm-extension/modules/UtilsOBM.jsm");

const Cc = Components.classes;
const Ci = Components.interfaces;
const Cr = Components.results;

function UnixFileWriter () {
}

UnixFileWriter.prototype.classID = Components.ID("{d2e49656-9ccd-4e4e-82a7-24c987af14a8}");
UnixFileWriter.prototype.contractID = "@obm.org/calendar/writer;1?type=unixfile";
UnixFileWriter.prototype.classDescription = "OBM Logger Writter: UnixFile";

/* instance methods */
UnixFileWriter.prototype.init = function (obj) {
    this._initialized = true;

    try {
      let fileName = UtilsOBM.getPrefSafe("extensions.obm.log.file") || "obm-connector-log.txt";

      var file = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
      file.append(fileName);
      this._file = file;
      this._stream = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);

      //	see: http://mxr.mozilla.org/mozilla/source/nsprpub/pr/include/prio.h
      //	PR_WRONLY		0x02
      //	PR_CREATE_FILE	0x08
      //	PR_APPEND 0x10
      this._stream.init(this._file, 0x02 | 0x08 | 0x10 , 0666, 0);


      var hello = "New session: " + Date() + "\n";
      this._stream.write(hello, hello.length);
      this._stream.flush();
    } catch(e) {
		dump("Error initializing log file: " + e + "\n");
    }
};

UnixFileWriter.prototype.write = function (msg, level) {
  /* Color
	var color;
	switch (level) {
		case Ci.obmILogger.DEBUG_LEVEL:
		color = "\033[34;1m";
		break;
		case Ci.obmILogger.NOTICE_LEVEL:
		color = "\033[32;1m";
		break;
		case Ci.obmILogger.WARNING_LEVEL:
		color = "\033[33;1m";
		break;
		case Ci.obmILogger.ERROR_LEVEL:
		color = "\033[31;1m";
		break;
		default:
		color = "";
	}
	msg = color + msg + "\033[m";
  */
  if (!this._initialized) {
    this.init(null);
  }
  if (this._stream) {
  	this._stream.write(msg, msg.length);
	  this._stream.flush();
  }
};

UnixFileWriter.prototype.QueryInterface = XPCOMUtils.generateQI([Ci.obmILoggerWriter]);

// module registration
var components = [UnixFileWriter];
if ("generateNSGetFactory" in XPCOMUtils) {
    var NSGetFactory = XPCOMUtils.generateNSGetFactory(components);
} else {
    var NSGetModule = XPCOMUtils.generateNSGetModule(components);
}
