var EXPORTED_SYMBOLS = ["InfiniteTree"];

function InfiniteTree(type, tree, treechildren, onRequest) {
  this.type = type;
  this.tree = tree;
  this.boxObject = tree.boxObject;
  this.treeChildren = treechildren;
  this.rowCount = 0;
  this.bypassScrollEvent = false;
  this.onRequest = onRequest;
  this.rowsInUI = 10;
  this.onScroll = this.onScrollCallback.bind(this);
};

InfiniteTree.prototype.boundFn = null;

InfiniteTree.prototype.onScrollCallback = function() {
  if (this.bypassScrollEvent) {
    return;
  }
  var currentBottomItem;
  try {
    currentBottomItem = this.boxObject.getLastVisibleRow();
  } catch(e) {
    return ;
  }
  if (currentBottomItem < this.rowsInUI || currentBottomItem >= this.rowCount) {
    this.bypassScrollEvent = true;
    this.onRequest();
  }
};

InfiniteTree.prototype.bind = function() {
  this.bypassScrollEvent = false;
  this.treeChildren.addEventListener('scroll', this.onScroll, false);
};

InfiniteTree.prototype.unbind = function() {
  this.treeChildren.removeEventListener('scroll', this.onScroll, false);
};

InfiniteTree.prototype.cleanTree = function() {
  while (this.treeChildren.firstChild) {
    this.treeChildren.removeChild(this.treeChildren.firstChild);
  }
  this.rowCount = 0;
}

InfiniteTree.prototype.addChildren = function(treeItems) {
  this.tree.setAttribute("hidden","false");

  for each(item in treeItems) {
    this.treeChildren.appendChild(item);
    this.rowCount++;
  }
  this.bypassScrollEvent = false;
};
